<template>
  <textarea
    :type="type"
    :class="$style.textarea"
    :name="name"
    :disabled="disabled"
    v-model="value"
    :placeholder="placeholder"
    :cols="cols"
    @input="onChange"
  />
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  name: "BaseTextarea",
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    defaultValue: {
      type: String,
      required: false,
      default: ""
    },
    name: {
      type: String,
      required: true,
      default: ""
    },
    type: {
      type: String,
      required: false,
      default: "text"
    },
    placeholder: {
      type: String,
      required: false,
      default: ""
    },
    cols: {
      type: [Number, String],
      required: false,
      default: 5
    }
  },
  data: function() {
    return {
      value: this.defaultValue || ""
    };
  },
  methods: {
    onChange: function() {
      this.$emit("onChange", this.value);
    }
  }
});
</script>

<style module lang="scss">
.textarea {
  width: 100%;
  box-shadow: $shadow--default;
  border: none;
  padding: 1rem 1rem;
  box-sizing: border-box;
}
</style>
